package com.icontrols.livechecker;

import java.io.File;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class LiveChecker {
	private static final Logger logger = LoggerFactory.getLogger(LiveChecker.class);
	
	// 복수개 지원현자을 구분하여 수신포트 변경을 위한 체크 파일
	private static final String MULTI_COMPANY_FILE =  "/service/multi_company.dat";
	private int port = 8098;
	
	public boolean getMutiCompanyServer() {
		File checkFile = new File(MULTI_COMPANY_FILE);

		logger.info("getMutiCompanyServer checkFile.exists() : " + checkFile.exists());
		if (checkFile.exists())
			return true;
		else
			return false;
	}
	
	
	public LiveChecker()
	{
		int Count = 0 ;
		
		if( getMutiCompanyServer())
			port = 2227;
		
		while(true)
		{

			try
			{
				Thread.sleep(1000*30); // 30초마다 라이브 체크 하도록 한다.
				
				
				boolean ret = sendMsg();
				
				if( ret == false)
					Count++;
				else 
					Count = 0;
				
				logger.debug("LiveCheck Count : " + Count + ", ret : " + ret);
				
				if( Count > 5 )
				{
					// 서비스 재로딩...
					Count = 0;
					logger.debug("~~~~~ restart Service module ");
					restart_Module();
				}
			}
			catch(Exception e)
			{
				
			}
		}
	}
	
	public void restart_Module()
	{
		try
		{
			ShRunner shRunner = new ShRunner();
			String cmds = "sh /service/live_checker/run.sh";
	        String[] callCmd = {"/bin/bash", "-c", cmds};
	        Map map = shRunner.execCommand(callCmd);
		}
		catch( Exception e )
		{
			logger.error("exception : " + e.toString());
		}
    }
	
	
	public boolean sendMsg()
	{
		//int port = 8098;
		//int port = 2227;
		
    	iMapRequestSysnc imapSocket = new iMapRequestSysnc("127.0.0.1", port);
    	
    	String xmlData = null;
    	xmlData = MakeXML.MakeXMLHeader( 101 , 101, "live_Check") + MakeXML.MakeXMLTail();
    	
    	int bRet = imapSocket.doWork(xmlData);
    	//logger.debug(" bRet : " + bRet  );
    	
    	if(bRet == 0 )
    		return true;
    	else 
    		return false;

	}
}
